LOCAL loForm AS FORM, ; 
  laPICS[1], ; 
  i AS INTEGER, ; 
  loCtrl AS COMMANDBUTTON
CD HOME(2) + [\Data\Graphics]
SET CLASSLIB TO HOME() + [FFC\_datanav.vcx] ADDITIVE 

*-- Fill a cursor with GIFs
ADIR(laPICS, [*.GIF])
CREATE CURSOR MyCursor (FName c(15), Pic BLOB) 
FOR i = 1 TO ALEN(laPICS, 1) 
  INSERT INTO MyCursor VALUES ; 
    (laPICS[i, 1], FILETOSTR(laPICS[i, 1])) 
ENDFOR 
GO TOP 

*-- Create a form and add an
*-- IMAGE control and the standard
*-- data navigation VCR buttons. 
loForm = NEWOBJECT([Form]) 

WITH loForm AS FORM 
  .ADDOBJECT([IMG], [IMAGE]) 
  .ADDOBJECT([NAV], [_NAVBTNS]) 
  .IMG.PictureVal = MyCursor.Pic 
  .IMG.VISIBLE = .T. 
  .NAV.VISIBLE = .T. 
  .NAV.ManyAlias = [MyCursor] 
  .NAV.TOP = .HEIGHT - .NAV.HEIGHT 
  .NAV.LEFT = .WIDTH - .NAV.WIDTH 
  *-- This keeps the buttons locked to 
  *-- bottom/right of form as form resizes. New to 9! 
  .NAV.ANCHOR = 12 
  .CAPTION = MyCursor.FName 
  *-- Use an event handler to handle the CLICK() 
  *-- of each of the VCR buttons. Easiest way to add 
  *-- code without modifying the class. 
  .ADDOBJECT([Handler], [MyHandler]) 
  FOR EACH loCtrl IN loForm.NAV.CONTROLS 
    BINDEVENT(loCtrl, [Click], .Handler, ;
      [NavHandler], 1) 
  ENDFOR 

  *-- Add edit box to display contents of the BLOB 
  *-- field... purely for interest's sake. 
  .ADDOBJECT([EDT1], [EDITBOX]) 
  .EDT1.VALUE = MyCursor.Pic 
  .EDT1.VISIBLE = .T. 
  .EDT1.LEFT = .IMG.LEFT + .IMG.WIDTH - 10 
  .EDT1.HEIGHT = .IMG.HEIGHT 
  .EDT1.WIDTH = .IMG.WIDTH 
  .EDT1.READONLY = .T. 
  .AUTOCENTER = .T. 
  .SHOW(1)
ENDWITH
CLOSE DATA ALL 

*----------------------------------------------
DEFINE CLASS MyHandler AS CUSTOM 
  FUNCTION NavHandler 
    *-- This is bound to the CLICK() of 
    *-- each button on the VCR buttons 
    *-- and is run after that code fires. 
    WITH THIS.PARENT AS FORM 
      .CAPTION = MyCursor.FName 
      .IMG.PictureVal = MyCursor.Pic 
      .EDT1.VALUE = MyCursor.Pic 
      .EDT1.REFRESH() 
    ENDWITH
ENDDEFINE
